package org.dromara.work.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.work.domain.TpCategory;
import org.dromara.work.domain.bo.TpCategoryBo;
import org.dromara.work.domain.vo.TpCategoryVo;
import org.dromara.work.mapper.TpCategoryMapper;
import org.dromara.work.service.ITpCategoryService;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 作品类目Service业务层处理
 *
 * @author Maosw
 * @date 2025-04-11
 */
@RequiredArgsConstructor
@Service
public class TpCategoryServiceImpl implements ITpCategoryService {

    private final TpCategoryMapper baseMapper;

    /**
     * 查询作品类目
     *
     * @param id 主键
     * @return 作品类目
     */
    @Override
    public TpCategoryVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }


    /**
     * 查询符合条件的作品类目列表
     *
     * @param bo 查询条件
     * @return 作品类目列表
     */
    @Override
    public List<TpCategoryVo> queryList(TpCategoryBo bo) {
        LambdaQueryWrapper<TpCategory> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<TpCategory> buildQueryWrapper(TpCategoryBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<TpCategory> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(TpCategory::getId);
        lqw.eq(bo.getParentId() != null, TpCategory::getParentId, bo.getParentId());
        lqw.like(StringUtils.isNotBlank(bo.getName()), TpCategory::getName, bo.getName());
        lqw.eq(StringUtils.isNotBlank(bo.getIcon()), TpCategory::getIcon, bo.getIcon());
        lqw.eq(StringUtils.isNotBlank(bo.getPic()), TpCategory::getPic, bo.getPic());
        lqw.eq(bo.getStatus() != null, TpCategory::getStatus, bo.getStatus());
        lqw.between(params.get("beginCreateTime") != null && params.get("endCreateTime") != null,
            TpCategory::getCreateTime ,params.get("beginCreateTime"), params.get("endCreateTime"));
        return lqw;
    }

    /**
     * 新增作品类目
     *
     * @param bo 作品类目
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(TpCategoryBo bo) {
        TpCategory add = MapstructUtils.convert(bo, TpCategory.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改作品类目
     *
     * @param bo 作品类目
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(TpCategoryBo bo) {
        TpCategory update = MapstructUtils.convert(bo, TpCategory.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(TpCategory entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除作品类目信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }

    /**
     * 根据id查询子id
     *
     * @param categoryId
     * @return 作品类目列表
     */
    @Override
    public List<Long> selectListIds(Long categoryId) {
        return baseMapper.selectList(new LambdaQueryWrapper<TpCategory>().eq(TpCategory::getParentId, categoryId)).stream().map(TpCategory::getId).toList();
    }
}
